/*
 *	LPT routines for REX-SMA02 programmed by Hanimar.
 *	'REX-SMA02 Parallel SmartMedia Reader/Writer' is a trademark of 
 *	RATOC Systems,Inc.
 *	Greet to TSG of Non-Standard.
 */
#include <stdio.h>
#include "sma02.h"

static int UseBidirectional = 0;

/*
 *	v^|[g REX-SMA02 pɃZbgAbvAł
 *	[hݒĒʐM\ԂɂB
 *	[h́A
 *		00:nibble read/byte write
 *		01:byte read/byte write
 *	łB
 *	ꉞĂ񂾂 Sma02Close() ĂԂ悤ɂĂB
 *	ʂ͕܂񂯂ǁB
 *
 *	߂lF
 *	0,1: SMA02 ̌ʃR[h
 *	-1: ߂B
 */
int Sma02Open(int base, int mode)
{
	int rc;
	int ret;
	/*
	 *	v^ REX-SMA02 ɈڂB
	 */
	OUT(LPTCTRL(base), 0x0e);	OUT(LPTSTAT(base), 0);
	OUT(LPTDATA(base), 0xf0);	OUT(LPTSTAT(base), 0);
	OUT(LPTCTRL(base), 0x06);	OUT(LPTSTAT(base), 0);
	OUT(LPTDATA(base), 0x00);	OUT(LPTSTAT(base), 0);

	OUT(LPTCTRL(base), 0x0e);	OUT(LPTSTAT(base), 0);
	OUT(LPTDATA(base), 0x50);	OUT(LPTSTAT(base), 0);
	OUT(LPTCTRL(base), 0x06);	OUT(LPTSTAT(base), 0);
	OUT(LPTDATA(base), 0xa0);	OUT(LPTSTAT(base), 0);

	OUT(LPTCTRL(base), 0x0e);	OUT(LPTSTAT(base), 0);
	OUT(LPTDATA(base), 0x50);	OUT(LPTSTAT(base), 0);
	OUT(LPTCTRL(base), 0x06);	OUT(LPTSTAT(base), 0);
	OUT(LPTDATA(base), 0xa0);	OUT(LPTSTAT(base), 0);

	OUT(LPTCTRL(base), 0x0e);	OUT(LPTSTAT(base), 0);		/* SELIN  LO  */
	OUT(LPTCTRL(base), 0x06);	OUT(LPTSTAT(base), 0);		/* SELIN=HI, ALF=LO sKvH */
	OUT(LPTDATA(base), mode?1:0); OUT(LPTSTAT(base), 0);	/* ǂݍ݂̃[hݒ */
	OUT(LPTCTRL(base), 0x06);	OUT(LPTSTAT(base), 0);		/* SELIN=HI, ALF=LO */
	
	/* ERR=HI,SEL=HI,PE=HI,ACK=LO ɂȂ̂҂B */
	rc = LptWaitStatus(base, STS_ERR|STS_SEL|STS_PE|STS_ACK, STS_ERR|STS_SEL|STS_PE, 1000);
	if (rc < 0) return rc;
	
	OUT(LPTCTRL(base), 0x07);	OUT(LPTSTAT(base), 0);		/* STB=LO */
	WaitMSec(1L);	/* 500ns ȏ҂ */
	OUT(LPTCTRL(base), 0x04);	OUT(LPTSTAT(base), 0);		/* ALF=HI STB=HI */

	/* 500ns ̊Ԃ ERR=LO,PE=LO ɂȂ ACK=HI ɂȂ邻 */
	rc = LptWaitStatus(base, STS_ERR|STS_PE, 0, 100);
	if (rc < 0) return rc;
	ret = (rc & STS_SEL) ? 1:0;	/* 500ns ̊ԂɎ󂯎KvƂAȂB */
	rc = LptWaitStatus(base, STS_ACK, STS_ACK, 100);
	if (rc < 0) return rc;
	
	if (mode && ret == 1) UseBidirectional = 1;
	else UseBidirectional = 0;

	return ret;
}

/*
 *	v^|[g REX-SMA02 ł̂J܂B
 */
int Sma02Close(int base)
{
	int c;
	
	Sma02Reset(base);
	Sma02Write1Byte(base, 1, 0x18);	/* VCC OFF */
	c = IN(LPTCTRL(base));
	OUT(LPTCTRL(base), 0x0c);	/* SELIN  LOB_B */
	return 0;
}

/*
 *	ju[h
 *	which ͓ǂݍޑΏۂŁA
 *	1: Xe[^XWX^ 0: f[^WX^B
 *
 *	ł ACK  HI ɂȂA LO ɂȂAĂ낢돑Ă܂A
 *	hCo͈؂݂ĂȂłB
 */
void Sma02NibbleRead(int base, int which, char *buffer, int len)
{
	int ctrl = IN(LPTCTRL(base));
	char n1, n2;
	char c;
	
	/* ǂݍޑΏۂ INIT ɐݒ */
	ctrl &= ~CTL_INIT;
	if (which) ctrl |= CTL_INIT;
	/* Ô ALF  HI ɂĂ܂Bi_j */
	ctrl &= ~CTL_ALF;

	while (len --) {
		OUT(LPTCTRL(base), ctrl);

		OUT(LPTCTRL(base), ctrl|CTL_ALF);	/* ALF=LO */
		n1 = IN(LPTSTAT(base));
		OUT(LPTCTRL(base), ctrl);
		
		OUT(LPTCTRL(base), ctrl|CTL_ALF);	/* ALF=LO */
		n2 = IN(LPTSTAT(base));
		OUT(LPTCTRL(base), ctrl);
		
		c = (n1 >> 3) & 0x07;	/* bit0,1,2 */
		c |= ((~n1) >> 4) & 0x08;	/* bit3 */
		c |= (n2 << 1) & 0x70;	/* bit4,5,6 */
		c |= (~n2) & 0x80;			/* bit7 */
		*buffer ++ = c;
	}
	return;
}

/*
 *	oCg[h
 *	v^|[gΉĂKv܂B
 *
 *	which ͓ǂݍޑΏۂŁA
 *	1: Xe[^XWX^ 0: f[^WX^B
 *
 *	 SMA02  ACK ǂ͈̂ؖĂ悢悤łB
 */
void Sma02ByteRead(int base, int which, char *buffer, int len)
{
	char c;
	int ctrl = IN(LPTCTRL(base));

	/* STB  HI i_jALF  HI  */
	ctrl &= ~CTL_STB;
	ctrl &= ~CTL_ALF;
	/* ǂݍޑΏۂ INIT ɐݒ */
	ctrl &= ~CTL_INIT;
	if (which) ctrl |= CTL_INIT;
	
	while (len --) {
		OUT(LPTCTRL(base), ctrl | CTL_DIR);	/* [h[h */
//		OUT(LPTCTRL(base), ctrl | CTL_DIR);	/* WX^w */
		OUT(LPTCTRL(base), ctrl | CTL_DIR | CTL_ALF);	/* ALF=LOi_j */
		*buffer ++ = IN(LPTDATA(base));
		OUT(LPTCTRL(base), ctrl);	/* ɖ߂ */
	}
	return;
}

/*
 *	static ϐ Bidirectional  Sma02ByteRead  Sma02NibbleRead IČĂԁB
 */
void Sma02Read(int base, int which, char *buffer, int len)
{
	static void (*sma02read[])(int base, int which, char *buffer, int len) = {
		Sma02NibbleRead, Sma02ByteRead
	};
	
	(sma02read[UseBidirectional])(base, which, buffer, len);
	return;
}
/*
 *	PoCgǂ
 */
UCHAR Sma02Read1Byte(int base, int which)
{
	UCHAR ret;
	
	Sma02Read(base, which, &ret, 1);
	return ret;
}

/*
 *	݁B
 *	which ͏ޑΏۂŁA
 *	1: Rg[WX^(mode register) 0: f[^WX^B
 *
 *	܂ SMA02  ACK ǂ͈̂ؖĂ悢悤łB
 */
void Sma02ByteWrite(int base, int which, const char *data, int len)
{
	int ctrl = IN(LPTCTRL(base));
	/* ÔߑS HI ̏Ԃ */
	ctrl &= 0xf0;
	ctrl |= 0x04;
	/* ޑΏۂ INIT ɐݒ */
	ctrl &= ~CTL_INIT;
	if (which) ctrl |= CTL_INIT;

	while (len --) {
		OUT(LPTDATA(base), *data); data ++;
		OUT(LPTCTRL(base), ctrl);		
		OUT(LPTCTRL(base), ctrl | CTL_STB);		/* STB=LO */
		OUT(LPTCTRL(base), ctrl);				/* STB=HI */
	}
	return;
}

/*
 *	PoCgM邱Ƃ܂ɑ̂ŁB
 */
void Sma02Write1Byte(int base, int which, const char data)
{
	int ctrl = IN(LPTCTRL(base));
	/* ÔߑS HI ̏Ԃ */
	ctrl &= 0xf0;
	ctrl |= 0x04;
	/* ޑΏۂ INIT ɐݒ */
	ctrl &= ~CTL_INIT;
	if (which) ctrl |= CTL_INIT;

	OUT(LPTDATA(base), data);
	OUT(LPTCTRL(base), ctrl);		
	OUT(LPTCTRL(base), ctrl | CTL_STB);		/* STB=LO */
	OUT(LPTCTRL(base), ctrl);				/* STB=HI */

	return;
}


/*
 *	R}ho
 */
void Sma02WriteCommand(int base, UCHAR cmd)
{
	UCHAR reg = 0x91;
	Sma02ByteWrite(base, 1, &reg, 1);
	Sma02ByteWrite(base, 0, &cmd, 1);
	
	return;
}

/*
 *	R}hIH
 */
void Sma02Reset(int base)
{
	UCHAR reg;
	
	reg = 0; Sma02ByteWrite(base, 1, &reg, 1);
	Sma02WriteCommand(base, 0xff);
	reg = 0x90; Sma02ByteWrite(base, 1, &reg, 1);
	reg = 0; Sma02ByteWrite(base, 1, &reg, 1);
	
	return;
}

void Sma02ReadID(int base, char *dest)
{
	UCHAR reg, data;
	
	Sma02Reset(base);
	Sma02WriteCommand(base, 0x90);
	reg = 0x92; Sma02ByteWrite(base, 1, &reg, 1);
	data = 0; Sma02ByteWrite(base, 0, &data, 1);
	reg = 0x90; Sma02ByteWrite(base, 1, &reg, 1);
	Sma02Read(base, 0, dest, 3);

	return;
}

UCHAR Sma02ReadStatus(int base)
{
	Sma02WriteCommand(base, 0x70);
	Sma02Write1Byte(base, 1, 0x90);
	return Sma02Read1Byte(base, 1);
}

int Sma02EraseBlock(int base, int blockNo)
{
	UCHAR reg, data;
	UCHAR status;
	int ret = 0;
	int retry;
	
	Sma02WriteCommand(base, 0x60);
	reg = 0x92; Sma02ByteWrite(base, 1, &reg, 1); /* AhX */
	data = blockNo & 0xff; Sma02ByteWrite(base, 0, &data, 1);
	data = (blockNo >> 8) & 0xff; Sma02ByteWrite(base, 0, &data, 1);
	Sma02WriteCommand(base, 0xd0);	/* s */
	/* BUSY ̊ԑ҂ */
	for (retry = 10000 ; retry ; retry --) {
		status = Sma02Read1Byte(base, 1);
		if (!(status & 0x80)) break;
	}
	if (!retry) {
		Sma02Reset(base);
		return -1;
	}
	status = Sma02ReadStatus(base);
	reg = 0x00; Sma02ByteWrite(base, 1, &reg, 1);

	return (status & 1) ? -1 : 0;
}
/*
 *	nBlock  8MB  1024 łB
 */
int Sma02EraseAll(int base, int nBlock)
{
	UCHAR reg, data;
	int i;
	UCHAR status;
	int ret = 0;
	int retry;
	
	for (i = 0 ; i < nBlock ; i ++) {
		Sma02WriteCommand(base, 0x60);
		reg = 0x92; Sma02ByteWrite(base, 1, &reg, 1); /* AhX */
		data = (i << 4) & 0xf0; Sma02ByteWrite(base, 0, &data, 1);
		data = (i >> 4) & 0xff; Sma02ByteWrite(base, 0, &data, 1);
		Sma02WriteCommand(base, 0xd0);	/* s */
		/* BUSY ̊ԑ҂ */
		for (retry = 10000 ; retry ; retry --) {
			status = Sma02Read1Byte(base, 1);
			if (!(status & 0x80)) break;
		}
		if (!retry) {
			Sma02Reset(base);
			return -1;
		}
		status = Sma02ReadStatus(base);
		reg = 0x00; Sma02ByteWrite(base, 1, &reg, 1);
		if (status & 1) {
			ret --;
		}
	}
	return ret;
}

/*
 *	y[Wǂݍ
 *	buffer ɂ 512 + 16 bytes mۂĂB
 *	address  pageNo + (blockNo << 4) w肵ĂB
 *	1block  16pages łB
 *	8M  blockNo  0  1023 ̊ԂłB
 *	pageNo  0  15 łB
 *	nPage ͓ǂ݂y[WB
 *
 *	procedure ͂Py[WǂނƂɌĂ΂܂B Ȃ NULL w肵ĂB
 *  procedure w肵ꍇׂ͂Ẵy[W buffer ɏ㏑܂B
 *	w肵Ȃ buffer i߂ď܂B
 *	procedure()  0ȊOԂƏ𒆎~܂B
 */
void Sma02ReadPage(int base, UCHAR *buffer, int address, int nPage,
	int (*procedure)(UCHAR *buffer, void *userData), void *userData)
{
	UCHAR reg;
	UCHAR data;
	UCHAR status;
	int retry;
	
	reg = 0x90; Sma02ByteWrite(base, 1, &reg, 1);
	Sma02WriteCommand(base, 0x00);	/* ǂݏo */
	reg = 0x92; Sma02ByteWrite(base, 1, &reg, 1);	/* AhXo */
	data = 0x00; Sma02ByteWrite(base, 0, &data, 1);	/* y[W̃AhXO */
	data = (UCHAR)(address & 0xff);
	Sma02ByteWrite(base, 0, &data, 1);	/* PoCg */
	data = (UCHAR)((address >> 8) & 0xff);
	Sma02ByteWrite(base, 0, &data, 1);	/* QoCg */
	/* eʂ̃fBȀꍇ͂PoCgM悤ł... */
	reg = 0x90; Sma02ByteWrite(base, 1, &reg, 1);	/* CE  LO ɌŒ */
	/* BUSY ̊ԑ҂ */

	for (retry = 10000 ; retry ; retry --) {
		status = Sma02Read1Byte(base, 1);
		if (!(status & 0x80)) break;
	}
	if (!retry) {
		Sma02Reset(base);
		return -1;
	}
	
	while (nPage > 0) {
		Sma02Read(base, 0, buffer, 528);
		if (procedure != NULL) {
			if ((procedure)(buffer, userData) != 0) break;
		} else buffer += 528;
		nPage --;
	}
	Sma02Reset(base);
	return;
}
/*
 *	PS2 ͂PZN^ 2page ȂŁAp̂Ă܂傤B
 *	EDC ̈̂ 1024 bytes 𓾂܂B
 */
int Sma02ReadSector(int base, UCHAR *buffer, int address)
{
	UCHAR data;
	UCHAR status;
	int retry;
	
	Sma02Write1Byte(base, 1, 0x90);
	Sma02WriteCommand(base, 0x00);	/* ǂݏo */
	Sma02Write1Byte(base, 1, 0x92);	/* AhXo */
	Sma02Write1Byte(base, 0, 0x00);	/* y[W̃AhXO */
	Sma02Write1Byte(base, 0, address & 0xff);			/* PoCg */
	Sma02Write1Byte(base, 0, (address >> 8) & 0xff);	/* QoCg */

	Sma02Write1Byte(base, 1, 0x90);	/* CE  LO ɌŒ */
	/* BUSY ̊ԑ҂ */

	for (retry = 10000 ; retry ; retry --) {
		status = Sma02Read1Byte(base, 1);
		if (!(status & 0x80)) break;
	}
	if (!retry) {
		Sma02Reset(base);
		return -1;
	}

	Sma02Read(base, 0, buffer, 528);
	Sma02Read(base, 0, &buffer[512], 512);

	Sma02Reset(base);
	return 0;
}

/*
 *	[Aꉽł傤H
 */
void Sma02ReadPage2(int base, UCHAR *buffer, int address, int nPage,
	int (*procedure)(UCHAR *buffer, void *userData), void *userData)

{
	Sma02WriteCommand(base, 0x5a);
	Sma02WriteCommand(base, 0xb5);
	Sma02ReadPage(base, buffer, address, nPage, procedure, userData);
	return;
}

int Sma02WritePage(int base, const UCHAR *pageData, int address)
{
	UCHAR reg;
	UCHAR data;
	UCHAR status;
	int retry;
	
	reg = 0x90; Sma02ByteWrite(base, 1, &reg, 1);
	Sma02WriteCommand(base, 0x80);	/* o */
	reg = 0x92; Sma02ByteWrite(base, 1, &reg, 1);	/* AhXo */
	data = 0x00; Sma02ByteWrite(base, 0, &data, 1);	/* y[W̃AhXO */
	
	data = (UCHAR)(address & 0xff);
	Sma02ByteWrite(base, 0, &data, 1);	/* PoCg */
	data = (UCHAR)((address >> 8) & 0xff);
	Sma02ByteWrite(base, 0, &data, 1);	/* QoCg */
	/* eʂ̃fBȀꍇ͂PoCgM悤ł... */
	reg = 0x90; Sma02ByteWrite(base, 1, &reg, 1);	/* CE  LO ɌŒ */

	/* BUSY ̊ԑ҂ */
	for (retry = 10000 ; retry ; retry --) {
		Sma02Read(base, 1, &status, 1);
		if (!(status & 0x80)) break;
	}
	if (!retry) {
		Sma02Reset(base);	/* Ƃ̂łł܂ */
		return -2;
	}

	Sma02ByteWrite(base, 0, pageData, 528);
	Sma02WriteCommand(base, 0x10);	/* s */
	/* BUSY ̊ԑ҂ */
	for (retry = 10000 ; retry ; retry --) {
		Sma02Read(base, 1, &status, 1);
		if (!(status & 0x80)) break;
	}
	if (!retry) {
		Sma02Reset(base);	/* Ƃ̂łł܂ */
		return -2;
	}

	status = Sma02ReadStatus(base);
	reg = 0x00; Sma02ByteWrite(base, 1, &reg, 1);
	
	return (status & 1) ? -1 : 0;
}
